--
-- VariableSteering
-- 
-- 
--
--
-- @author:		fruktor (wwww.modding-society.de)
-- @version:	v0.1
-- @date:		08/12/10
-- @history:	v0.1 - inital implementation
--
-- Copyright (C) 
--

VariableSteering = {};

function VariableSteering.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function VariableSteering:load(xmlFile)
	
	self.setActiveSteering = SpecializationUtil.callSpecializationsFunction("setActiveSteering");
	
	self.varSteer = {};
	self.varSteer.wheels = {};
	self.varSteer.types = {};
	self.varSteer.types[1] = "all";
	self.varSteer.types[2] = "front";
	self.varSteer.types[3] = "back";
	self.varSteer.types[4] = "dog";
	self.varSteer.typeCount = 4;
	self.varSteer.activeType = 1;
		
	--for i,j in pairs(self.wheels) do
		--print("wheel: "..i.." ="..tostring(j));
		--print("wheel.driveMode="..j.driveMode);
		--print("wheel.rotSpeed=".. j.rotSpeed .. " wheel.rotMax/Min=" .. j.rotMax .. "/" .. j.rotMin);
		--self.varSteer.wheels[i] = j;
	--end;
	
	self.varSteer.rotSpeed = 70;
	self.varSteer.rotSpeed = Utils.degToRad(self.varSteer.rotSpeed);
	
	self.varSteer.rotMax = 18;
	self.varSteer.rotMax = Utils.degToRad(self.varSteer.rotMax);
	
	self.varSteer.rotMin = -18;
	self.varSteer.rotMin = Utils.degToRad(self.varSteer.rotMin);
end;	
	

function VariableSteering:delete()
end;

function VariableSteering:readStream(streamId, connection)
	self.varSteer.activeType = streamReadInt8(streamId);
end;

function VariableSteering:writeStream(streamId, connection)
	streamWriteInt8(streamId, self.varSteer.activeType);
end;

function VariableSteering:mouseEvent(posX, posY, isDown, isUp, button)
end;

function VariableSteering:keyEvent(unicode, sym, modifier, isDown)
end;

function VariableSteering:update(dt)

	if self:getIsActiveForInput() then
		
		if InputBinding.hasEvent(InputBinding.VARIABLESTEERING_change) then
			local idx = self.varSteer.activeType + 1;
			if idx > self.varSteer.typeCount then
				idx = 1;
			end;
			self:setActiveSteering(idx);
		end;
	end;

end;

function VariableSteering:updateTick(dt)
	if self.varSteer.changed == true then
		if string.match("all", self.varSteer.types[self.varSteer.activeType]) then
			self.wheels[1].driveMode = 2;
			self.wheels[2].driveMode = 2;
			self.wheels[1].rotSpeed = self.varSteer.rotSpeed;
			self.wheels[2].rotSpeed = self.varSteer.rotSpeed;
			self.wheels[1].rotMax = self.varSteer.rotMax;
			self.wheels[2].rotMax = self.varSteer.rotMax;
			self.wheels[1].rotMin = self.varSteer.rotMin;
			self.wheels[2].rotMin = self.varSteer.rotMin;

			self.wheels[3].driveMode = 2;
			self.wheels[4].driveMode = 2;
			self.wheels[3].rotSpeed = -self.varSteer.rotSpeed;
			self.wheels[4].rotSpeed = -self.varSteer.rotSpeed;
			self.wheels[3].rotMax = self.varSteer.rotMax;
			self.wheels[4].rotMax = self.varSteer.rotMax;
			self.wheels[3].rotMin = self.varSteer.rotMin;
			self.wheels[4].rotMin = self.varSteer.rotMin;			
		end;
		if string.match("front", self.varSteer.types[self.varSteer.activeType]) then
			self.wheels[1].driveMode = 2;
			self.wheels[2].driveMode = 2;
			self.wheels[1].rotSpeed = self.varSteer.rotSpeed;
			self.wheels[2].rotSpeed = self.varSteer.rotSpeed;
			self.wheels[1].rotMax = self.varSteer.rotMax;
			self.wheels[2].rotMax = self.varSteer.rotMax;
			self.wheels[1].rotMin = self.varSteer.rotMin;
			self.wheels[2].rotMin = self.varSteer.rotMin;
			
			self.wheels[3].driveMode = 1;
			self.wheels[4].driveMode = 1;
			self.wheels[3].rotSpeed = 0;
			self.wheels[4].rotSpeed = 0;
			self.wheels[3].rotMax = 0;
			self.wheels[4].rotMax = 0;
			self.wheels[3].rotMin = 0;
			self.wheels[4].rotMin = 0;
		end;
		if string.match("back", self.varSteer.types[self.varSteer.activeType]) then
			self.wheels[1].driveMode = 1;
			self.wheels[2].driveMode = 1;
			self.wheels[1].rotSpeed = 0;
			self.wheels[2].rotSpeed = 0;
			self.wheels[1].rotMax = 0;
			self.wheels[2].rotMax = 0;
			self.wheels[1].rotMin = 0;
			self.wheels[2].rotMin = 0;

			self.wheels[3].driveMode = 2;
			self.wheels[4].driveMode = 2;
			self.wheels[3].rotSpeed = -self.varSteer.rotSpeed;
			self.wheels[4].rotSpeed = -self.varSteer.rotSpeed;
			self.wheels[3].rotMax = self.varSteer.rotMax;
			self.wheels[4].rotMax = self.varSteer.rotMax;
			self.wheels[3].rotMin = self.varSteer.rotMin;
			self.wheels[4].rotMin = self.varSteer.rotMin;	
		end;		
		if string.match("dog", self.varSteer.types[self.varSteer.activeType]) then
			self.wheels[1].driveMode = 2;
			self.wheels[2].driveMode = 2;
			self.wheels[1].rotSpeed = self.varSteer.rotSpeed;
			self.wheels[2].rotSpeed = self.varSteer.rotSpeed;
			self.wheels[1].rotMax = self.varSteer.rotMax;
			self.wheels[2].rotMax = self.varSteer.rotMax;
			self.wheels[1].rotMin = self.varSteer.rotMin;
			self.wheels[2].rotMin = self.varSteer.rotMin;

			self.wheels[3].driveMode = 2;
			self.wheels[4].driveMode = 2;
			self.wheels[3].rotSpeed = self.varSteer.rotSpeed;
			self.wheels[4].rotSpeed = self.varSteer.rotSpeed;
			self.wheels[3].rotMax = self.varSteer.rotMax;
			self.wheels[4].rotMax = self.varSteer.rotMax;
			self.wheels[3].rotMin = self.varSteer.rotMin;
			self.wheels[4].rotMin = self.varSteer.rotMin;	
		end;		
		
		self.varSteer.changed = false;
	end;
end;

function VariableSteering:draw()
	
	if self:getIsActive() then
		g_currentMission:addHelpButtonText(
			string.format(g_i18n:getText("VARIABLESTEERING_change"), self.varSteer.types[self.varSteer.activeType]),InputBinding.VARIABLESTEERING_change);
	end;
end;

function VariableSteering:onAttach()
end;

function VariableSteering:onDetach()
end;

function VariableSteering:onLeave()
end;

function VariableSteering:onDeactivate()
end;

function VariableSteering:onDeactivateSounds()
end;

function VariableSteering:setActiveSteering(index, noEventSend)
	VariableSteeringEvent.sendEvent(self, index, noEventSend);
	self.varSteer.activeType = index;
	self.varSteer.changed  = true;
end;


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
--
-- VariableSteeringEvent
--
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
VariableSteeringEvent = {};
VariableSteeringEvent_mt = Class(VariableSteeringEvent, Event);

InitEventClass(VariableSteeringEvent, "VariableSteeringEvent");

function VariableSteeringEvent:emptyNew()
    local self = Event:new(VariableSteeringEvent_mt);
    self.className = "VariableSteeringEvent";
    return self;
end;

function VariableSteeringEvent:new(object, state)
    local self = VariableSteeringEvent:emptyNew()
    self.object = object;
	self.state = state;
    return self;
end;

function VariableSteeringEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.state = streamReadInt8(streamId);
    self.object = networkGetObject(id);
    self:run(connection);
end;

function VariableSteeringEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteInt8(streamId, self.state);
end;

function VariableSteeringEvent:run(connection)
	self.object:setActiveSteering(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(VariableSteeringEvent:new(self.object, self.state), nil, connection, self.object);
    end;	
end;

function VariableSteeringEvent.sendEvent(vehicle, state, noEventSend)
	if state ~= vehicle.varSteer.activeType then
		if noEventSend == nil or noEventSend == false then
			if g_server ~= nil then
				g_server:broadcastEvent(VariableSteeringEvent:new(vehicle, state), nil, nil, vehicle);
			else
				g_client:getServerConnection():sendEvent(VariableSteeringEvent:new(vehicle, state));
			end;
		end;
	end;
end;

